"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../lib/service");
var async = require("async");
var mongodb = require("mongodb");
var MongodbService = /** @class */ (function (_super) {
    __extends(MongodbService, _super);
    function MongodbService(settings) {
        var _this = _super.call(this, {
            database: {
                port: 27017,
                host: "localhost",
                name: "test"
            }
        }, settings) || this;
        _this.name = "MongodbService";
        return _this;
    }
    MongodbService.prototype.initialize = function (done) {
        var _this = this;
        var _a = this.settings.database, host = _a.host, port = _a.port, name = _a.name;
        console.log("Connecting to database", "mongodb://" + host + ":" + port + "/" + name);
        mongodb.MongoClient.connect("mongodb://" + host + ":" + port, function (err, client) {
            _this.db = client.db(name);
            done(err);
        });
    };
    MongodbService.prototype.asBuiltIn = function () {
        var _a = this.settings.database, host = _a.host, port = _a.port, name = _a.name;
        console.log("MongodbService using mongo://" + host + ":" + port + "/" + name);
    };
    MongodbService.prototype.ensureIndexes = function (indexes, callback) {
        async.eachSeries(indexes, function (data, done) {
            if (!data.option)
                data.option = {};
            console.log("Indexing " + data.collection.namespace + ":" + Object.keys(data.key).join("&") + " => " + (data.option.nonunique && "" || "unique") + " " + (data.option.sparse && "sparse"));
            data.collection.createIndex(data.key, {
                unique: !data.option.nonunique,
                sparse: data.option.sparse
            }, done);
        }, callback);
    };
    return MongodbService;
}(service_1.Service));
exports.MongodbService = MongodbService;
//# sourceMappingURL=mongodbService.js.map